

<!DOCTYPE html>

<html lang="ja">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.15.31. vector_find &#8212; Groonga v10.1.1-31-g1e46ba6ドキュメント</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    <script src="../../_static/translations.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="索引" href="../../genindex.html" />
    <link rel="search" title="検索" href="../../search.html" />
    <link rel="next" title="7.15.32. vector_new" href="vector_new.html" />
    <link rel="prev" title="7.15.30. time_classify_year" href="time_classify_year.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">オープンソースのカラムストア機能付き全文検索エンジン</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../en/html/reference/functions/vector_find.html">English</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             accesskey="I">索引</a></li>
        <li class="right" >
          <a href="vector_new.html" title="7.15.32. vector_new"
             accesskey="N">次へ</a> |</li>
        <li class="right" >
          <a href="time_classify_year.html" title="7.15.30. time_classify_year"
             accesskey="P">前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../function.html" accesskey="U"><span class="section-number">7.15. </span>関数</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.15.31. </span><code class="docutils literal notranslate"><span class="pre">vector_find</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="vector-find">
<h1><span class="section-number">7.15.31. </span><code class="docutils literal notranslate"><span class="pre">vector_find</span></code><a class="headerlink" href="#vector-find" title="このヘッドラインへのパーマリンク">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.15.31.1. </span>概要<a class="headerlink" href="#summary" title="このヘッドラインへのパーマリンク">¶</a></h2>
<div class="versionadded">
<p><span class="versionmodified added">バージョン 8.0.4 で追加.</span></p>
</div>
<p>指定したベクターから指定した条件にマッチする最初の要素を返します。どの要素もマッチしない場合は <code class="docutils literal notranslate"><span class="pre">null</span></code> を返します。</p>
<p>等価条件だけでなく以下条件や前方一致条件なども使えます。</p>
<p>この関数を有効にするには、以下のコマンドで <code class="docutils literal notranslate"><span class="pre">functions/vector</span></code> プラグインを登録します。:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>plugin_register functions/vector
</pre></div>
</div>
</div>
<div class="section" id="syntax">
<span id="vector-find-syntax"></span><h2><span class="section-number">7.15.31.2. </span>構文<a class="headerlink" href="#syntax" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">vector_find</span></code> のパラメーター数は2つまたは3つです。:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>vector_find(vector, value)
vector_find(vector, value, mode)
</pre></div>
</div>
<p>3番目の引数を省略すると、 <code class="docutils literal notranslate"><span class="pre">vector</span></code> 内の各要素と <code class="docutils literal notranslate"><span class="pre">value</span></code> の比較には等価条件を使います。</p>
</div>
<div class="section" id="usage">
<span id="vector-find-usage"></span><h2><span class="section-number">7.15.31.3. </span>使い方<a class="headerlink" href="#usage" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>まず <code class="docutils literal notranslate"><span class="pre">functions/vector</span></code> プラグインを登録します。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>plugin_register functions/vector
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>使い方を示すために使うスキーマ定義とサンプルデータは以下の通りです。</p>
<p>サンプルスキーマ:</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create  Memos TABLE_HASH_KEY ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Memos tags COLUMN_VECTOR ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>サンプルデータ:</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>load --table Memos
[
{&quot;_key&quot;: &quot;Groonga is fast&quot;,          &quot;tags&quot;: [&quot;groonga&quot;]},
{&quot;_key&quot;: &quot;Mroonga is fast&quot;,          &quot;tags&quot;: [&quot;mroonga&quot;, &quot;groonga&quot;]},
{&quot;_key&quot;: &quot;Groonga is very good!&quot;,    &quot;tags&quot;: [&quot;groonga&quot;]},
{&quot;_key&quot;: &quot;Droonga is fast&quot;,          &quot;tags&quot;: [&quot;droonga&quot;, &quot;groonga&quot;]},
{&quot;_key&quot;: &quot;Groonga is a HTTP server&quot;, &quot;tags&quot;: [&quot;groonga&quot;, &quot;http&quot;]}
]
# [[0, 1337566253.89858, 0.000355720520019531], 5]
</pre></div>
</div>
<p>以下は <code class="docutils literal notranslate"><span class="pre">vector_find</span></code> の簡単な使い方です。この使い方では <code class="docutils literal notranslate"><span class="pre">tags</span></code> カラム内の要素を検索して最初に見つかった要素を返します。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select \
  --table Memos \
  --output_columns &#39;tags, vector_find(tags, &quot;mroonga&quot;)&#39;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         5
#       ],
#       [
#         [
#           &quot;tags&quot;,
#           &quot;ShortText&quot;
#         ],
#         [
#           &quot;vector_find&quot;,
#           null
#         ]
#       ],
#       [
#         [
#           &quot;groonga&quot;
#         ],
#         null
#       ],
#       [
#         [
#           &quot;mroonga&quot;,
#           &quot;groonga&quot;
#         ],
#         &quot;mroonga&quot;
#       ],
#       [
#         [
#           &quot;groonga&quot;
#         ],
#         null
#       ],
#       [
#         [
#           &quot;droonga&quot;,
#           &quot;groonga&quot;
#         ],
#         null
#       ],
#       [
#         [
#           &quot;groonga&quot;,
#           &quot;http&quot;
#         ],
#         null
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>この例では <code class="docutils literal notranslate"><span class="pre">tags</span></code> カラムの中に <code class="docutils literal notranslate"><span class="pre">&quot;mroonga&quot;</span></code> がある場合は <code class="docutils literal notranslate"><span class="pre">&quot;mroonga&quot;</span></code> を返し、そうでない場合は <code class="docutils literal notranslate"><span class="pre">null</span></code> を返しています。</p>
<p>3番目の引数でそれぞれの値をどうやって比較するかをカスタマイズできます。以下は要素の検索に全文検索を使う例です。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select \
  --table Memos \
  --output_columns &#39;tags, vector_find(tags, &quot;roonga&quot;, &quot;@&quot;)&#39;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         5
#       ],
#       [
#         [
#           &quot;tags&quot;,
#           &quot;ShortText&quot;
#         ],
#         [
#           &quot;vector_find&quot;,
#           null
#         ]
#       ],
#       [
#         [
#           &quot;groonga&quot;
#         ],
#         &quot;groonga&quot;
#       ],
#       [
#         [
#           &quot;mroonga&quot;,
#           &quot;groonga&quot;
#         ],
#         &quot;mroonga&quot;
#       ],
#       [
#         [
#           &quot;groonga&quot;
#         ],
#         &quot;groonga&quot;
#       ],
#       [
#         [
#           &quot;droonga&quot;,
#           &quot;groonga&quot;
#         ],
#         &quot;droonga&quot;
#       ],
#       [
#         [
#           &quot;groonga&quot;,
#           &quot;http&quot;
#         ],
#         &quot;groonga&quot;
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>この例では <code class="docutils literal notranslate"><span class="pre">tags</span></code> カラム内に <code class="docutils literal notranslate"><span class="pre">&quot;groonga&quot;</span></code> 、 <code class="docutils literal notranslate"><span class="pre">&quot;mroonga&quot;</span></code> 、 <code class="docutils literal notranslate"><span class="pre">&quot;droonga&quot;</span></code> のどれかが含まれていれば、最初に見つかったその値を返します。たとえば、 <code class="docutils literal notranslate"><span class="pre">[&quot;droonga&quot;,</span> <span class="pre">&quot;groonga&quot;]</span></code> の場合は <code class="docutils literal notranslate"><span class="pre">&quot;droonga&quot;</span></code> を返します。 <code class="docutils literal notranslate"><span class="pre">&quot;groonga&quot;</span></code> は返しません。なぜなら、2つ目の要素である <code class="docutils literal notranslate"><span class="pre">&quot;groonga&quot;</span></code> を検索する前に最初の要素である <code class="docutils literal notranslate"><span class="pre">&quot;droonga&quot;</span></code> がマッチするからです。</p>
<p>この例では <code class="docutils literal notranslate"><span class="pre">tags</span></code> カラム内に <code class="docutils literal notranslate"><span class="pre">&quot;groonga&quot;</span></code> 、 <code class="docutils literal notranslate"><span class="pre">&quot;mroonga&quot;</span></code> 、 <code class="docutils literal notranslate"><span class="pre">&quot;droonga&quot;</span></code> のどの値も含まれていない場合は <code class="docutils literal notranslate"><span class="pre">null</span></code> を返します。</p>
</div>
<div class="section" id="parameters">
<span id="vector-find-parameters"></span><h2><span class="section-number">7.15.31.4. </span>引数<a class="headerlink" href="#parameters" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>必須の引数は2つです。</p>
<p>省略可能な引数があります。</p>
<div class="section" id="required-parameters">
<span id="vector-find-required-parameters"></span><h3><span class="section-number">7.15.31.4.1. </span>必須引数<a class="headerlink" href="#required-parameters" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p><code class="docutils literal notranslate"><span class="pre">vector</span></code> と <code class="docutils literal notranslate"><span class="pre">value</span></code> は必須です。</p>
<div class="section" id="vector">
<span id="vector-find-vector"></span><h4><span class="section-number">7.15.31.4.1.1. </span><code class="docutils literal notranslate"><span class="pre">vector</span></code><a class="headerlink" href="#vector" title="このヘッドラインへのパーマリンク">¶</a></h4>
<p>検索対象のベクターを指定します。</p>
</div>
<div class="section" id="value">
<span id="vector-find-value"></span><h4><span class="section-number">7.15.31.4.1.2. </span><code class="docutils literal notranslate"><span class="pre">value</span></code><a class="headerlink" href="#value" title="このヘッドラインへのパーマリンク">¶</a></h4>
<p>比較対象の値を指定します。</p>
</div>
</div>
<div class="section" id="optional-parameters">
<span id="vector-find-optional-parameters"></span><h3><span class="section-number">7.15.31.4.2. </span>省略可能引数<a class="headerlink" href="#optional-parameters" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p><code class="docutils literal notranslate"><span class="pre">mode</span></code> は省略可能です。</p>
<div class="section" id="mode">
<span id="vector-find-mode"></span><h4><span class="section-number">7.15.31.4.2.1. </span><code class="docutils literal notranslate"><span class="pre">mode</span></code><a class="headerlink" href="#mode" title="このヘッドラインへのパーマリンク">¶</a></h4>
<p><a class="reference internal" href="#vector-find-value"><span class="std std-ref">value</span></a> と各要素を比較する方法（モード）を指定します。</p>
<p>利用可能なモード名は <a class="reference internal" href="query.html#query-default-mode"><span class="std std-ref">default_mode</span></a> を見てください。 <code class="docutils literal notranslate"><span class="pre">&quot;NEAR&quot;</span></code> 、 <code class="docutils literal notranslate"><span class="pre">&quot;SIMILAR&quot;</span></code> と <code class="docutils literal notranslate"><span class="pre">&quot;SUFFIX&quot;</span></code> 以外のすべてのモード名をサポートしています。</p>
<p>デフォルトのモードは <code class="docutils literal notranslate"><span class="pre">&quot;EQUAL&quot;</span></code> です。 <a class="reference internal" href="query.html#query-default-mode"><span class="std std-ref">default_mode</span></a> ではデフォルトのモードは <code class="docutils literal notranslate"><span class="pre">&quot;MATCH&quot;</span></code> ですが、 <code class="docutils literal notranslate"><span class="pre">vector_find</span></code> のデフォルトのモードは <code class="docutils literal notranslate"><span class="pre">&quot;EQUAL&quot;</span></code> です。</p>
</div>
</div>
</div>
<div class="section" id="return-value">
<h2><span class="section-number">7.15.31.5. </span>戻り値<a class="headerlink" href="#return-value" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>マッチした場合はマッチした要素。マッチしない場合は <code class="docutils literal notranslate"><span class="pre">null</span></code> 。</p>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">目次</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.15.31. <code class="docutils literal notranslate"><span class="pre">vector_find</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.15.31.1. 概要</a></li>
<li><a class="reference internal" href="#syntax">7.15.31.2. 構文</a></li>
<li><a class="reference internal" href="#usage">7.15.31.3. 使い方</a></li>
<li><a class="reference internal" href="#parameters">7.15.31.4. 引数</a><ul>
<li><a class="reference internal" href="#required-parameters">7.15.31.4.1. 必須引数</a><ul>
<li><a class="reference internal" href="#vector">7.15.31.4.1.1. <code class="docutils literal notranslate"><span class="pre">vector</span></code></a></li>
<li><a class="reference internal" href="#value">7.15.31.4.1.2. <code class="docutils literal notranslate"><span class="pre">value</span></code></a></li>
</ul>
</li>
<li><a class="reference internal" href="#optional-parameters">7.15.31.4.2. 省略可能引数</a><ul>
<li><a class="reference internal" href="#mode">7.15.31.4.2.1. <code class="docutils literal notranslate"><span class="pre">mode</span></code></a></li>
</ul>
</li>
</ul>
</li>
<li><a class="reference internal" href="#return-value">7.15.31.5. 戻り値</a></li>
</ul>
</li>
</ul>

  <h4>前のトピックへ</h4>
  <p class="topless"><a href="time_classify_year.html"
                        title="前の章へ"><span class="section-number">7.15.30. </span><code class="docutils literal notranslate"><span class="pre">time_classify_year</span></code></a></p>
  <h4>次のトピックへ</h4>
  <p class="topless"><a href="vector_new.html"
                        title="次の章へ"><span class="section-number">7.15.32. </span><code class="docutils literal notranslate"><span class="pre">vector_new</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">クイック検索</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="検索" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             >索引</a></li>
        <li class="right" >
          <a href="vector_new.html" title="7.15.32. vector_new"
             >次へ</a> |</li>
        <li class="right" >
          <a href="time_classify_year.html" title="7.15.30. time_classify_year"
             >前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../function.html" ><span class="section-number">7.15. </span>関数</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.15.31. </span><code class="docutils literal notranslate"><span class="pre">vector_find</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>